setvirtualresolution(1024,768)

// Add TMX engine to project
#include "tmx_engine.agc"


// Initialize tmx library
gosub _tmx_init


// Load a tmx map
tmx_LoadMap("example.tmx")





repeat


    gosub _Controls


    // Update map position
    tmx_SetMapPosition(offsetX, offsetY)


    t = tmx_GetTileIndex(1, getRawMouseX(), getRawMouseY())
    // Draws a box around the specified grid tile
    tmx_DrawGridTile(t, 0,255,0)


    // Get tile in grid coordinates
    t = t - 1
    ty = floor(t / TMX_Map.mapWidth)
    tx = t - ty*TMX_Map.mapWidth


    print(str(tx)+":"+str(ty))
    print("")
    print("1. Orthogonal")
    print("2. Isometric")
    print("3. Staggered")
    print("4. Zelda")
    print("")
    print("Load Time: "+str(loadTime))


    sync()
until getRawKeyPressed(32) = 1
end




_Controls:
    if getRawMouseLeftState() = 1
        if moveFlag = 0
            moveFlag = 1
            oldMx = offsetX - getRawMouseX()
            oldMy = offsetY - getRawMouseY()
        endif
        if moveFlag = 1
            offsetX = getRawMouseX() + oldMx
            offsetY = getRawMouseY() + oldMy
        endif
    else
        moveFlag = 0
    endif

    if getRawKeyPressed(49) = 1
        tmx_FreeMap()
        tbase = getMilliseconds()
        tmx_LoadMap("example.tmx")
        loadTime = getMilliseconds() - tbase
    endif
    if getRawKeyPressed(50) = 1
        tmx_FreeMap()
        tbase = getMilliseconds()
        tmx_LoadMap("isometric_grass_and_water.tmx")
        loadTime = getMilliseconds() - tbase
    endif
    if getRawKeyPressed(51) = 1
        tmx_FreeMap()
        tbase = getMilliseconds()
        tmx_LoadMap("staggered.tmx")
        loadTime = getMilliseconds() - tbase
    endif
    if getRawKeyPressed(52) = 1
        tmx_FreeMap()
        tbase = getMilliseconds()
        tmx_LoadMap("overworld.tmx")
        loadTime = getMilliseconds() - tbase
    endif
RETURN
